diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/helper/yans-wifi-helper.h ns-3.43/src/wifi/helper/yans-wifi-helper.h
--- ns-3.42/src/wifi/helper/yans-wifi-helper.h	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/helper/yans-wifi-helper.h	2024-10-09 16:41:10.112656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2008 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/addba-extension.cc ns-3.43/src/wifi/model/addba-extension.cc
--- ns-3.42/src/wifi/model/addba-extension.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/addba-extension.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/addba-extension.h ns-3.43/src/wifi/model/addba-extension.h
--- ns-3.42/src/wifi/model/addba-extension.h	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/addba-extension.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/adhoc-wifi-mac.cc ns-3.43/src/wifi/model/adhoc-wifi-mac.cc
--- ns-3.42/src/wifi/model/adhoc-wifi-mac.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/adhoc-wifi-mac.cc	2024-10-09 16:41:10.116656800 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2006, 2009 INRIA
  * Copyright (c) 2009 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Mirko Banchi <mk.banchi@gmail.com>
@@ -72,9 +61,10 @@
 }
 
 void
-AdhocWifiMac::Enqueue(Ptr<Packet> packet, Mac48Address to)
+AdhocWifiMac::Enqueue(Ptr<WifiMpdu> mpdu, Mac48Address to, Mac48Address from)
 {
-    NS_LOG_FUNCTION(this << packet << to);
+    NS_LOG_FUNCTION(this << *mpdu << to << from);
+
     if (GetWifiRemoteStationManager()->IsBrandNew(to))
     {
         // In ad hoc mode, we assume that every destination supports all the rates we support.
@@ -113,65 +103,17 @@
         GetWifiRemoteStationManager()->RecordDisassociated(to);
     }
 
-    WifiMacHeader hdr;
-
-    // If we are not a QoS STA then we definitely want to use AC_BE to
-    // transmit the packet. A TID of zero will map to AC_BE (through \c
-    // QosUtilsMapTidToAc()), so we use that as our default here.
-    uint8_t tid = 0;
-
-    // For now, a STA that supports QoS does not support non-QoS
-    // associations, and vice versa. In future the STA model should fall
-    // back to non-QoS if talking to a peer that is also non-QoS. At
-    // that point there will need to be per-station QoS state maintained
-    // by the association state machine, and consulted here.
-    if (GetQosSupported())
-    {
-        hdr.SetType(WIFI_MAC_QOSDATA);
-        hdr.SetQosAckPolicy(WifiMacHeader::NORMAL_ACK);
-        hdr.SetQosNoEosp();
-        hdr.SetQosNoAmsdu();
-        // Transmission of multiple frames in the same TXOP is not
-        // supported for now
-        hdr.SetQosTxopLimit(0);
-
-        // Fill in the QoS control field in the MAC header
-        tid = QosUtilsGetTidForPacket(packet);
-        // Any value greater than 7 is invalid and likely indicates that
-        // the packet had no QoS tag, so we revert to zero, which will
-        // mean that AC_BE is used.
-        if (tid > 7)
-        {
-            tid = 0;
-        }
-        hdr.SetQosTid(tid);
-    }
-    else
-    {
-        hdr.SetType(WIFI_MAC_DATA);
-    }
+    auto& hdr = mpdu->GetHeader();
 
-    if (GetHtSupported(SINGLE_LINK_OP_ID))
-    {
-        hdr.SetNoOrder(); // explicitly set to 0 for the time being since HT control field is not
-                          // yet implemented (set it to 1 when implemented)
-    }
     hdr.SetAddr1(to);
     hdr.SetAddr2(GetAddress());
-    hdr.SetAddr3(GetBssid(0));
+    hdr.SetAddr3(GetBssid(SINGLE_LINK_OP_ID));
     hdr.SetDsNotFrom();
     hdr.SetDsNotTo();
 
-    if (GetQosSupported())
-    {
-        // Sanity check that the TID is valid
-        NS_ASSERT(tid < 8);
-        GetQosTxop(tid)->Queue(packet, hdr);
-    }
-    else
-    {
-        GetTxop()->Queue(packet, hdr);
-    }
+    auto txop = hdr.IsQosData() ? StaticCast<Txop>(GetQosTxop(hdr.GetQosTid())) : GetTxop();
+    NS_ASSERT(txop);
+    txop->Queue(mpdu);
 }
 
 void
@@ -239,9 +181,7 @@
         return;
     }
 
-    // Invoke the receive handler of our parent class to deal with any
-    // other frames. Specifically, this will handle Block Ack-related
-    // Management Action frames.
+    // Invoke the receive handler of our parent class to deal with any other frames
     WifiMac::Receive(mpdu, linkId);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/adhoc-wifi-mac.h ns-3.43/src/wifi/model/adhoc-wifi-mac.h
--- ns-3.42/src/wifi/model/adhoc-wifi-mac.h	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/adhoc-wifi-mac.h	2024-10-09 16:41:10.116656800 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2006, 2009 INRIA
  * Copyright (c) 2009 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Mirko Banchi <mk.banchi@gmail.com>
@@ -45,12 +34,12 @@
     ~AdhocWifiMac() override;
 
     void SetLinkUpCallback(Callback<void> linkUp) override;
-    void Enqueue(Ptr<Packet> packet, Mac48Address to) override;
     bool CanForwardPacketsTo(Mac48Address to) const override;
 
   private:
     void Receive(Ptr<const WifiMpdu> mpdu, uint8_t linkId) override;
     void DoCompleteConfig() override;
+    void Enqueue(Ptr<WifiMpdu> mpdu, Mac48Address to, Mac48Address from) override;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ampdu-subframe-header.cc ns-3.43/src/wifi/model/ampdu-subframe-header.cc
--- ns-3.42/src/wifi/model/ampdu-subframe-header.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/ampdu-subframe-header.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2013
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Ghada Badawy <gbadawy@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ampdu-subframe-header.h ns-3.43/src/wifi/model/ampdu-subframe-header.h
--- ns-3.42/src/wifi/model/ampdu-subframe-header.h	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/ampdu-subframe-header.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2013
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Ghada Badawy <gbadawy@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ampdu-tag.cc ns-3.43/src/wifi/model/ampdu-tag.cc
--- ns-3.42/src/wifi/model/ampdu-tag.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/ampdu-tag.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2013
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Ghada Badawy <gbadawy@gmail.com>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ampdu-tag.h ns-3.43/src/wifi/model/ampdu-tag.h
--- ns-3.42/src/wifi/model/ampdu-tag.h	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/ampdu-tag.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2013
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Ghada Badawy <gbadawy@gmail.com>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/amsdu-subframe-header.cc ns-3.43/src/wifi/model/amsdu-subframe-header.cc
--- ns-3.42/src/wifi/model/amsdu-subframe-header.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/amsdu-subframe-header.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mirko Banchi <mk.banchi@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/amsdu-subframe-header.h ns-3.43/src/wifi/model/amsdu-subframe-header.h
--- ns-3.42/src/wifi/model/amsdu-subframe-header.h	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/amsdu-subframe-header.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mirko Banchi <mk.banchi@gmail.com>
  */
